/* =========================================================================
	This library is part of IshiSoft CEHTTP base class.
	------------------------------------------------------------------------
	Last-Modified: Mon, 25 Nov 2002 GMT
	
	author: yu-ishi@ya2.so-net.ne.jp
			http://www001.upp.so-net.ne.jp/ishi/index.html
  ========================================================================== */
#if !defined(_MMyHash_H__INCLUDED_)
#define _MMyHash_H__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MyVarMem.h"

/* ****************************************************************************

  KeyValueyAœo^邱Ƃo
  ǉA폜AA񋓂o

  {\

  |key1|\0|value1|\0|key2|\0|value2|...|keyN|\0|valueN|\0|\0|

  EI[|\0|\0|
  Evalue\0
    |key1|\0|\0|key2|...
  EKey\0͋Ȃ

**************************************************************************** */
class MyHash
{
private:
	MyVarMem*	m_pHeap;					// NX
	char*		m_pszSeekPointer;			// Ce[^
	
public:
	void* GetBuffer() const;
	int GetLength()			{return m_pHeap->GetLength();}

	char*	SeekToFirst();
	char*	SeekToKey(char* pszKey);
	char*	SeekToKeyI(char* pszKey);
	char*	GetCurrentKey();
	char*	GetCurrentValue();
	char*	SeekNext();
	void	Clear()	{m_pHeap->Clear();	m_pszSeekPointer = NULL;}
	MyHash();
	virtual ~MyHash();

	int			Set( char* pszKey, char* pszValue );
	int			Del( char* pszKey);
	char*		GetValue( char* pszKey );
	char*		GetValueI(char* pszKey);
	//char*		GetValueE(char* pszKey);
	//char*		GetValueIE(char* pszKey);

protected:
	inline int ToLower( int c )
	{return (( c >= 'A' && c <= 'Z' ) ? c += ('a'-'A') : c);}
	inline int StrLen( const char *string )
	{
		for( int ii = 0; *string; ii++, string++ );
		return ii;
	}
	int StrCmpI( const char* str1, const char* str2 );
	int StrCmp( const char *str1, const char *str2 );

};

#endif // !defined(_MMyHash_H__INCLUDED_)
