// MyHttpSock.cpp: MyHttpSock NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include "MyVarMem.h"
#include "MyHash.h"
#include "MyHttpSock.h"
#include "MyTime.h"
#include "httphelper.h"

#ifndef _WIN32_WCE
#include <direct.h>
#endif

#include "resource.h"

TCHAR*	szG_VERSION_OF_MYHTTPSOCK_CPP = TEXT(__TIMESTAMP__);

#define	HEADER_LINE_MAX	512		// HeaderLines̈s̐l

// e|obt@
#define SOCKET_HEAD_BUF	1024	// \Pbgpobt@TCY
#define SOCKET_BODY_BUF	4096	// \Pbgpobt@TCY

// 
#define	STR_KEEP_ALIVE	"Keep-Alive"
#define STR_CLOSE		"Close"

//-----------------------------------------------
// [vĒTԂɂ̂ŁA0,2,5Ԃ͌ŒłB
#define HTTPSTATUS_200	0
#define HTTPSTATUS_302	2
#define HTTPSTATUS_401	5

HTTP_STATUS	hsStatus[] = 
{
	{200, "200 OK"								},	// 0
	{301, "301 Moved Permanently"				},
	{302, "302 Object Moved"					},	// 2
	{304, "304 Not Modified"					},
	{400, "400 Bad Request"						},
	{401, "401 Unauthorized"					},	// 5
	{403, "403 Access Forbidden"				},
	{404, "404 Object Not Found"				},
	{500, "500 Internal Server Error"			},
	{501, "501 Not Implemented"					},
	{999, "999 CGI"								},	// Ǝ
	{000, "500 Internal Server Error"			}	// terminate
};


//-----------------------------------------------
// content_type
// ܂葝₷ƃptH[}XIɕsB
// @wants
// WXg HKEY_CLASSES_ROOT  Content Type o

CONTENT_TYPE ct[] =
{
	{ ".html",	"text/html"						},
	{ ".htm",	"text/html"						},
	{ ".gif",	"image/gif"						},
	{ ".png",	"image/png"						},
	{ ".jpg",	"image/jpeg"					},
	{ ".jpeg",	"image/jpeg"					},
	{ ".txt",	"text/plain"					},
	{ ".css",	"text/css"						},
	{ ".bmp",	"image/bitmap"					},
	{ ".tif",	"image/tiff"					},
	{ ".tiff",	"image/tiff"					},
	{ ".mpg",	"video/mpeg"					},
	{ ".mpeg",	"video/mpeg"					},
	{ ".pdf",	"application/pdf"				},
	{ ".ls",	"application/x-javascript"		},
	{ ".js",	"application/x-javascript"		},
	{ ".mp3",	"audio/mp3"						},
	{ ".m3u",	"audio/x-mpegurl"				},
	{ ".wav",	"audio/x-wav"					},
	{ ".mid",	"audio/mid"						},
	{ ".midi",	"audio/mid"						},
	{ ".swf",	"application/x-shockwave-flash"	},
	{ ""	,	"application/octet-stream"		}
};

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

MyHttpSock::MyHttpSock()
{
	m_dwRecvTimeOut = 30000;
}

MyHttpSock::MyHttpSock(SOCKET s) : MySock(s)
{
	m_dwRecvTimeOut = 30000;

}

MyHttpSock::~MyHttpSock()
{
	FreeMemory();
}

//-----------------------------------------------------------------------------
//	@detail
//		HTTPNGXg͂AHTTPXe[^Xm
//	@param
//		int* pbClose	߂ɒʐM؂グtO
//	@return
//		0̓\Pbg֘AG[łȏʐMoȂ
//		ȊOHTTPXe[^XԂ
//-----------------------------------------------------------------------------
int MyHttpSock::RecvRequest(int* pbClose)
{
	char szHeadBuf[SOCKET_HEAD_BUF];
	m_hReqHead.Clear();
	m_hReqBody.Clear();
	timeval ptvTimeOut;
	char* pReq = NULL;
	strcpy(m_hrHttpReq.szHttpVer, "HTTP/1.0");

	GetTimeOut(&ptvTimeOut);

	//-------------------------------------------
	// MvZX
	//-------------------------------------------

	// Get http header
	DWORD	dwStartTime = GetTickCount();
	MyVarMem hReq;// = new MyVarMem;
	int nRecvLen;
	while(1)
	{
		char*	p;
		nRecvLen = RecvData(szHeadBuf, SOCKET_HEAD_BUF);

		if( nRecvLen == SOCKET_ERROR )		//*** \PbgG[
		{
			Close();
			return 0;
		}
		else if( nRecvLen > 0 )				//*** M
		{
			// RFC2626 sec.5
			hReq.Add((void*)szHeadBuf, nRecvLen);

			// wb_[I
			const char* pszReqHeadBuf = (const char*)hReq.GetBuffer();

			p = strstr(pszReqHeadBuf, "\r\n\r\n");

			// wb_[I
			if( p != NULL )
			{
				p += 4;
				// wb_[m_ReqHeadɒǉ
				int nHeaderLen = (p - pszReqHeadBuf);
				m_hReqHead.Add(hReq.GetBuffer(), nHeaderLen);
				
				// ǂ݂m_hReqBodyɒǉ
				int nDrop = hReq.GetLength() - nHeaderLen;
				if( nDrop > 0 )
					m_hReqBody.Add( p, nDrop);

				hReq.Clear();

				//-------------------------------------------------------------
				// NGXgwb_̈S̃`FbN
				// SẴCHEADER_LINE_MAXoCgȓłȂƃ_
				//-------------------------------------------------------------
				pReq = (char*)(const char*)m_hReqHead;
	
				for( int count = 0; *pReq; pReq++, count++ )
				{
					if( count > HEADER_LINE_MAX )
						return 400;	// Bad Request

					if( *pReq == '\r' )
					{
						count = 0;

						if( pReq[1] == '\0' )
							return 400;		// Bad Request
						
						pReq += 2;
						continue;
					}
				}

				// sڂ𕪉
				int ret;
				ret = WorkParseRequestLine((const char*)m_hReqHead);
				if( ret != 200 ) return ret;

				// sڈȍ~𕪉
				ret = WorkParseRequestHeader((const char*)m_hReqHead);
				if( ret != 200 ) return ret;

				// HTTP/1.1  Host:wb_K{
				// @RFC2616 sec.19.6.1.1
				if( !strcmp( m_hrHttpReq.szHttpVer, "HTTP/1.1" ) &&
					!m_hashReqHeader.GetValueI("host") )
					return 400;	// Bad Request

				break;
			}
		}
		else // ^CAEg
		{
		}


		// timeout check.
		DWORD dwSlipTime = (GetTickCount() - dwStartTime);
		
		// max 90sec. 47 days problem.
		if(	dwSlipTime > m_dwRecvTimeOut || dwSlipTime > 90000 )
		{
			//m_bKeepAlive = FALSE;
			return 504;	// Gateway Time-out
		}

		// ܂MĂȂԂőItO
		if( hReq.GetLength() == 0 && *pbClose )
		{
			return 504;
		}
	}	// end of while


	//-------------------------------------------
	// t@CpX
	//-------------------------------------------
	int status = WorkMakePath(m_hrHttpReq.szFilePath, MAX_PATH);

	// ------------------------------------------
	// eR}h̏
	// ------------------------------------------

	// --------------------------------
	// GET
	// --------------------------------
	if( m_hrHttpReq.HttpCmd == HTTPGET )
	{
		//-------------------------------------------
		// If-Modified-Since:̏
		// @RFC2616 sec.14.25 If-Modified-Since
		//-------------------------------------------
		if( status == 200 )
		{
			pReq = m_hashReqHeader.GetValueI("if-modified-since");
			if( pReq != NULL )
			{
				if( MyTime( pReq ) >= MyTime((m_hrHttpReq.wfdFile.ftLastWriteTime)) )
					return 304;
				else 
					return 200;
			}
		}
		return status;
	}
	// --------------------------------
	// POST
	// --------------------------------
	else if( m_hrHttpReq.HttpCmd == HTTPPOST )
	{
		char* p = m_hashReqHeader.GetValueI("content-length");
		
		if( p == NULL )
			return 400;	// Bad Request

		long lTotalSize = m_hReqBody.GetLength();
		long lContentLength = atol(p);

		if( lContentLength < 0 )
			return 400;	// Bad Request

		nRecvLen = 0;

		while(1)
		{
			// size check.
			lTotalSize += nRecvLen;
			if( lTotalSize >= lContentLength )
				return status;

			nRecvLen = RecvData(szHeadBuf, SOCKET_HEAD_BUF);

			// \PbgG[
			if( nRecvLen == SOCKET_ERROR )
			{
				m_hReqBody.Clear();
				return 0;
			}
			
			// ^CAEg
			else if( nRecvLen == 0 )
			{
			}

			m_hReqBody.Add((void*)szHeadBuf, nRecvLen);

			// timeout check.
			if( GetTickCount() - dwStartTime > m_dwRecvTimeOut )
			{
				m_hReqBody.Clear();
				return 504;	// Gateway Time-out
			}

		}
		return status;
	}
	else
	{
		return status;
	}
}

//-----------------------------------------------------------------------------
//	@detail
//		HTTPX|XԂ
//	@param
//		nHttpStatus		NGXgwb_[͌
//		int bClose	߂ɒʐM؂グtO
//								ftHg0łB
//	@return
//		0̓\Pbg֘AG[łȏʐMoȂ
//		ȊOHTTPXe[^XԂ
//-----------------------------------------------------------------------------
int MyHttpSock::SendResponse(int nHttpStatus, int bClose)
{
	char szHeadBuf[SOCKET_HEAD_BUF];
	char szBodyBuf[SOCKET_BODY_BUF];
	int	nSockStatus = 0;

	TCHAR	tszFile[MAX_PATH];
	// HTTPXe[^Xɏ]ĕԓ
	
	nHttpStatus = CheckBasicAuth(nHttpStatus, m_hrHttpReq.szFilePath, m_pServerInfo->pszAccessFileName);
	switch( nHttpStatus )
	{

		// ----------------------------------
		// ERROR
		// ----------------------------------
		case 0:
			return 0;

		// ====================================================================
		// 200 OK
		// ====================================================================
		case 200:
		{
			char* pszFPath = m_hrHttpReq.szFilePath;
			//int nFPathLen = strlen(pszFPath);
			
			// t@Cunicodeɕϊ
			if( 0 == MultiByteToWideChar(CP_ACP, 0, pszFPath, -1, tszFile, MAX_PATH) )
			{
				nHttpStatus = 500;	// Internal Server Error
				return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
			}

			// ------------------------------
			// HTTP/1.x OK xxxx
			// Server: xxxxx
			// Content-Length: xxxx
			// Last-Modified: Mon, 24 Sep 2001 15:20:34 GMT
			// Content-Type: xxxx/xxxx
			// ------------------------------
			sprintf(szHeadBuf, 
				"%s %s\r\n"
				"Server: %s\r\n"
				"Content-Length: %u\r\n"
				"Last-Modified: %s\r\n"
				"Connection: %s\r\n"
				
				, m_hrHttpReq.szHttpVer, hsStatus[HTTPSTATUS_200].pszString
				, m_pServerInfo->pszSoftware
				, m_hrHttpReq.wfdFile.nFileSizeLow
				, m_hrHttpReq.szFileTime
				, (bClose ? STR_CLOSE : STR_KEEP_ALIVE)
			);

			 if( (nSockStatus = SendData(szHeadBuf) < 1)) return 0;

			// ------------------------------
			// Content-Type: xxxx/xxxx
			// ------------------------------
			int ii = 0;
			int nFileNameLen = strlen( pszFPath );
			sprintf(szHeadBuf, "Content-Type: application/octet-stream\r\n\r\n" );

			while( *(ct[ii].pszExt) != '\0' )
			{
				int nExtTypeLen = strlen( ct[ii].pszExt );
				char* p = &pszFPath[nFileNameLen - nExtTypeLen];
				if( 0 == my_stricmp( ct[ii].pszExt, p ) )
				{
					sprintf(szHeadBuf, 
						"Content-Type: %s\r\n"
						"\r\n"
						, ct[ii].pszMIME );
					break;
				}
				ii++;
			}
			if( (nSockStatus = SendData(szHeadBuf) < 1)) return 0;
			
			DWORD	dwReadBytes;

			// ------------------------------
			// t@C]
			// ------------------------------
			
			// HEADR}h̏ꍇ̓t@CԑȂ
			if( m_hrHttpReq.HttpCmd == HTTPGET )
			{
				// t@CJ
				HANDLE hFile = CreateFile(
					tszFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);

				if( hFile == INVALID_HANDLE_VALUE )
				{
					nHttpStatus = 500;	// Internal Server Error
					return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
				}

				do
				{
					// ؂ăt@C]
					if( ReadFile( hFile, szBodyBuf, SOCKET_BODY_BUF, &dwReadBytes, NULL ) )
					{
						if( dwReadBytes == 0 )
						{
							break;
						}

						nSockStatus = SendData(szBodyBuf, dwReadBytes);
						if( nSockStatus < 1 )
						{
							CloseHandle( hFile );
							return 0;
						}
					}
					else
					{
						break;
					}
				}while( dwReadBytes > 0 );

				CloseHandle( hFile );
			}
			break;
		}

		// ====================================================================
		// 302 Object Moved.
		// ɃNGXg̍Ō'/'ȂꍇȂǂɎgB
		// ====================================================================
		case 302:
		{
			char* p = m_hrHttpReq.szFilePath;
			bslash2slash(p);
			// ------------------------------
			// Object may be here. xxxx
			// ------------------------------
			sprintf(szBodyBuf, 
				"<html><body><a href=\"%s\">Object may be here.</a><address>%s</address></body></html>"
				, m_hrHttpReq.szFilePath, m_pServerInfo->pszSoftware );

			// ------------------------------
			// HTTP/1.x 302 xxxx
			// Server: xxxxx
			// Location: xxxx
			// Content-Length: nnnn
			// Connection: Close/Keep-Alive
			// ------------------------------
			sprintf(szHeadBuf, 
				"%s %s\r\n"
				"Server: %s\r\n"
				"Location: %s\r\n"
				"Content-Length: %u\r\n"
				"Connection: %s\r\n"
				"Content-Type: text/html\r\n"
				"\r\n"
				
				, m_hrHttpReq.szHttpVer, hsStatus[HTTPSTATUS_302].pszString
				, (char*)m_pServerInfo->pszSoftware
				, m_hrHttpReq.szFilePath
				, strlen(szBodyBuf)
				, (bClose ? STR_CLOSE : STR_KEEP_ALIVE)
			);
			
			if( (nSockStatus = SendData(szHeadBuf) < 1)) return 0;
			if( (nSockStatus = SendData(szBodyBuf) < 1)) return 0;
			break;
		}

		// ====================================================================
		// 401 Access Denied
		// ====================================================================
		case 401:
			// ----------------------------------
			// HTTP/1.1 401 Access Denied
			// Server: xxxxx
			// WWW-Authenticate: Basic realm="xxxx"
			// Content-Length: nnnn
			// Content-Type: text/html
			// ----------------------------------
			char* pszHost;
			pszHost = ( m_hashReqHeader.GetValueI("host") );
			if( !pszHost )
				pszHost = "localhost";

			sprintf(szHeadBuf, 
				"%s %s\r\n"
				"Server: %s\r\n"
				"WWW-Authenticate: Basic realm=\"%s%s\"\r\n"
				"Connection: close\r\n"
				"Content-Type: text/html\r\n"
				"Content-Length: %u\r\n"
				"\r\n"
				"%s"
				
				,m_hrHttpReq.szHttpVer, hsStatus[HTTPSTATUS_401].pszString
				,(char*)m_pServerInfo->pszSoftware
				,  pszHost, m_hrHttpReq.szUrlPath

				, strlen(hsStatus[HTTPSTATUS_401].pszString)
				, hsStatus[HTTPSTATUS_401].pszString
			);
			
			if( (nSockStatus = SendData(szHeadBuf) < 1)) return 0;
			if( (nSockStatus = SendData(szBodyBuf) < 1)) return 0;
			break;

		// ====================================================================
		// 999 CehttpGatewayInterface
		// ====================================================================
		case 999:
		{
			WorkMakeEnv();
			char* pszFPath = m_hrHttpReq.szFilePath;
			int nFPathLen = strlen(pszFPath);
			
			// t@Cunicodeɕϊ
			if( 0 == MultiByteToWideChar(CP_ACP, 0, pszFPath, -1, tszFile, MAX_PATH) )
			{
				nHttpStatus = 500;	// Internal Server Error
				return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
			}

			// ----------------------------------------------------------------
			// CHX̌Ăяo
			// ----------------------------------------------------------------
			if( 0 == my_strnicmp( &pszFPath[nFPathLen] - 4, ".chx", 4 ) )
			{
				m_hashEnv.Set("GATEWAY_INTERFACE",	"CHX/1.0");

				MyVarMem hRes;
				// CHX DLL ̌Ăяo
				int (*pChx)(MyHash*, MyVarMem*, MyVarMem*);

				HMODULE hDLL = ::LoadLibrary(tszFile);
				if( hDLL == NULL )
				{
					nHttpStatus = 500;	// Internal Server Error
					return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
				}

				#ifndef _WIN32_WCE
					pChx=(int (*)(MyHash*, MyVarMem*, MyVarMem*))
						GetProcAddress(hDLL,"fnChx");
				#else
					pChx=(int (*)(MyHash*, MyVarMem*, MyVarMem*))
						GetProcAddress(hDLL,TEXT("fnChx"));
				#endif
				if( !pChx )
				{
					FreeLibrary(hDLL);
					nHttpStatus = 500;	// Internal Server Error
					return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
				}

				int nCgiResponceLen = pChx(&m_hashEnv, &m_hReqBody, &hRes);

				// FreeLibrary(hDLL); for Win32

				// ------------------------------
				// Locationwb_邩ǂ
				// ------------------------------
				char* phRes = (char*)hRes.GetBuffer();
				if( phRes == NULL )
				{
					nHttpStatus = 500;	// Internal Server Error
					return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
				}
				char* pRet = strstr( (const char*)phRes, "\r\n\r\n" );
				int nHeadlen;

				if( pRet != NULL )
				{
					nHeadlen = pRet - (const char*)hRes;
				}
				else
				{
					hRes.Clear();
					FreeLibrary(hDLL);
					nHttpStatus = 500;	// Internal Server Error
					return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
				}
				
				// CGItwb_[
				char* pszHead = new char[nHeadlen+1];
				strncpy(pszHead, hRes, nHeadlen);
				pszHead[nHeadlen] = '\0';

				// ------------------------------
				// wb_Location:𔭌ꍇ
				// Locationwb_Ĕ΂
				// Pȃ`FbNȂ̂Œ
				// ------------------------------
				if( strstr( pszHead, "Location:" ) != NULL )
				//if( my_stricmp( pszHead, "Location:" ) )
				{
					// ------------------------------
					// HTTP/1.x 302 Object Moved
					// Server: xxxxx
					// ------------------------------
					sprintf(szHeadBuf, 
						"%s %s\r\n"
						"Server: %s\r\n"
						, m_hrHttpReq.szHttpVer, hsStatus[HTTPSTATUS_302].pszString
						, m_pServerInfo->pszSoftware);
				}
				else
				{
					// ------------------------------
					// HTTP/1.x 200 OK
					// Server: xxxxx
					// ------------------------------
					sprintf(szHeadBuf, 
						"%s %s\r\n"
						"Server: %s\r\n"
						, m_hrHttpReq.szHttpVer, hsStatus[0].pszString
						, m_pServerInfo->pszSoftware);
				}
				delete pszHead;
				// CGItwb_[I

				// ʏ̃wb_̑o
				nSockStatus = SendData(szHeadBuf);

				// ------------------------------
				// CHXf[^̑M
				// Content-Type: XXXX/XXXX
				// 
				// <data>
				// ------------------------------
				nSockStatus = SendData(hRes, hRes.GetLength()); //CEHTTP2.1
				hRes.Clear();
				FreeLibrary(hDLL);
				break;
			}
			// ----------------------------------------------------------------
			// DLLĂяo̔
			// ----------------------------------------------------------------
			else if( 0 == my_strnicmp( &pszFPath[nFPathLen] - 4, ".dll", 4 ) )
			{
				// CGI DLL ̌Ăяo
				int (*pCAPI)(const void*, int, const void*, int, const void*, int, void**);

				HMODULE hDLL = ::LoadLibrary(tszFile);
				if( hDLL == NULL )
				{
					nHttpStatus = 500;	// Internal Server Error
					return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
				}

				#ifndef _WIN32_WCE
					pCAPI = (int (*)(const void*, int, const void*, int, const void*, int, void**))
						GetProcAddress(hDLL,"fnCAPI");
				#else
					pCAPI = (int (*)(const void*, int, const void*, int, const void*, int, void**))
						GetProcAddress(hDLL,TEXT("fnCAPI"));
				#endif

				if( !pCAPI )
				{
					nHttpStatus = 500;	// Internal Server Error
					return SendDefaultHttpResponse(nHttpStatus, bClose, __LINE__);
				}

				void* pCgiResponce = NULL;
				int nCgiResponceLen = pCAPI(
					m_hashEnv.GetBuffer(), m_hashEnv.GetLength(),
					m_hReqHead.GetBuffer(), m_hReqHead.GetLength(),
					m_hReqBody.GetBuffer(), m_hReqBody.GetLength(),
					&pCgiResponce);

				if( NULL != pCgiResponce )
				{
					nSockStatus = SendData((const char*)pCgiResponce, nCgiResponceLen);
					free(pCgiResponce);
				}
				FreeLibrary(hDLL);
				break;
			}
			// ----------------------------------------------------------------
			// ̑
			// ----------------------------------------------------------------
			else
			{
				//403 Access Forbidden
				nHttpStatus = 403;
				return SendDefaultHttpResponse(nHttpStatus, bClose);
			}
			break;
		}

		default:
		{
			return SendDefaultHttpResponse(nHttpStatus, bClose);
		}
	}

	if( nSockStatus < 1 )
	{
		return 0;
	}
	return nHttpStatus;
}

//-----------------------------------------------------------------------------
//	@detail
//		HTTP STATUSɏ]ĕԓԂ
//	@param
//		nHttpStatus		ԓ
//		int bClose	߂ɒʐM؂グtO
//								ftHg1łB
//	@return
//		M
//		0 SOCKET_ERROR
//	@RFC2616
//-----------------------------------------------------------------------------
int MyHttpSock::SendDefaultHttpResponse(int nHttpStatus, int bClose/*=0*/, int nAddtionalInfo/*=0*/)
{
	char szHeadBuf[512];
	
	char* pszErrorMsgHtml = NULL;
	int ii = 0;
	int nSockStatus = 0;

	// G[ԍTAuEU֕ԓ
	while(hsStatus[ii].nStatus != 0)
	{
		if( hsStatus[ii].nStatus == nHttpStatus )
		{
			pszErrorMsgHtml = (char*)hsStatus[ii].pszString;

			sprintf(szHeadBuf,
				"%s %s\r\n"
				"Server: %s\r\n"
				"Connection: %s\r\n"		// @RFC2616 sec.14.9
				"Content-Length: %u\r\n"
				"Content-Type: text/html\r\n"
				"\r\n"
				"%s(%d)"

				,m_hrHttpReq.szHttpVer, hsStatus[ii].pszString
				, m_pServerInfo->pszSoftware
				, (bClose ? STR_CLOSE : STR_KEEP_ALIVE)
				, strlen(pszErrorMsgHtml)
				, pszErrorMsgHtml
				, nAddtionalInfo
				);

			if( (nSockStatus = SendData(szHeadBuf) < 1)) return 0;
			break;
		}
		ii++;
	}
	return nHttpStatus;

}

//-----------------------------------------------------------------------------
//	@detail
//		{F
//	@param
//		pszFilePath		ANZXpX
//		pszBAuthFile	pX[ht@C
//	@return
//		nHttpSatus	ǂݎOK
//		401			F؂Kv
//		403			F؎s
//		500			InternalServerError
//	http://www.ietf.org/rfc/rfc2617.txt
//  RFC 2617
//-----------------------------------------------------------------------------
// WWW-Authenticate: Basic realm="localhost"
// HTTP/1.1 401 Access Denied
//-----------------------------------------------------------------------------
int MyHttpSock::CheckBasicAuth(int nHttpStatus, const char *pszFilePath, const char *pszBAuthFile)
{
	char	szFile[MAX_PATH];	// tmp
	char*	pszSerchPath;
	char*	p;
	int		nLen;
	int		nDocRootLen;
	int		nAuthFileLen;
	HANDLE hFile;
	WIN32_FIND_DATA FindFileData;

	// 
	memset( szFile, 0, MAX_PATH );
	nDocRootLen = strlen( m_pServerInfo->pszDocRootName );
	nAuthFileLen = strlen( pszBAuthFile );
	pszSerchPath = my_strdup( pszFilePath );

	if( pszSerchPath == NULL )
		return 500;

	do
	{
		// O\܂Ŗ߂
		// \aaa\bbb\ccc.ddd -> \aaa\bbb
		nLen = strlen( pszSerchPath );
		p = &pszSerchPath[nLen];
		while( *p != '\\' && p != pszSerchPath ) p--;
		*p = '\0';

		if( (nLen = strlen( pszSerchPath )) < nDocRootLen )
			break;

		// root ܂Ō
		if( pszSerchPath[0] == '\0' )
			break;

		strcpy( szFile, pszSerchPath );
		strcat( szFile, "\\" );
		strcat( szFile, pszBAuthFile );

		hFile = FindFirstFileMBCS( szFile, &FindFileData );

		if( hFile == INVALID_HANDLE_VALUE )
		{
			continue;
		}
		else
		{
			if( FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
				continue;

			FindClose( hFile );
			free( pszSerchPath );
			return CheckBasicAuthFile(nHttpStatus, szFile);
			break;

		}

	}while( 1 );

	free( pszSerchPath );
	return nHttpStatus;
}

//-----------------------------------------------------------------------------
//	@detail
//		F؃t@C̓ǂݎ
//	@param
//		
//	@return
//		nHttpSatus	ǂݎOK
//		401			F؂Kv
//		403			F؎s
//		500			InternalServerError
//	@comment
//		gC̓uEUŏÎŏ401Ԃ
//-----------------------------------------------------------------------------
// GET / HTTP/1.0
// Authorization: Basic aXNoaTo=
// User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)
// Host: localhost
// Connection: close
//-----------------------------------------------------------------------------
int MyHttpSock::CheckBasicAuthFile(int nHttpStatus, char* pszAuthFilePath)
{
	// --------------------------------------------------------------
	// Request header check.
	// --------------------------------------------------------------
	char* p = m_hashReqHeader.GetValueI("authorization");

	if( p == NULL )
		return 401; // Access Denied

	if( my_strnicmp(p, "basic", 5) != 0 )
		return 401;

	p += 5;
	while( *p == ' ' ) p++;

	// base64 decording.
	Base64Decord((unsigned char*)p);

	// --------------------------------------------------------------
	// passwd file open
	// --------------------------------------------------------------
	int	nFile = strlen(pszAuthFilePath);
	TCHAR*	ptszFile = new TCHAR[nFile+1];

	if( ptszFile == NULL )
	{
		// 500 InternalServerError
		return 500;
	}
	memset( ptszFile, 0, sizeof(TCHAR)*(nFile+1) );
	
	if( 0 == MultiByteToWideChar(CP_ACP,0,pszAuthFilePath,-1,ptszFile, nFile+1) )
	{
		delete[] ptszFile;
		// 500 InternalServerError
		return 500;
	}

	// --------------------------------------------------------------
	HANDLE hFile = CreateFile(ptszFile, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL);
	delete[] ptszFile;
	MyVarMem	vm;

	if( hFile == INVALID_HANDLE_VALUE )
	{
		return 500;	// Internal Server Error
	}
	else
	{
		char	szBuf[510];
		BOOL	bResult;
		DWORD	dwReadBytes;
		do
		{
			bResult = ReadFile( hFile, szBuf, 510, &dwReadBytes, NULL );
			
			if(dwReadBytes == 0)
				break;

			vm.Add( szBuf, dwReadBytes );

		}while( bResult );

		CloseHandle(hFile);
	}

	// ̃t@C牽Ȃ
	if( vm.GetLength() == 0 )
	{
		return nHttpStatus;
	}

	// --------------------------------------------------------------
	// password check.
	// --------------------------------------------------------------
	char*	pPasswd;
	char*	pNextPasswd;

	pPasswd = pNextPasswd = (char*)vm.GetBuffer();

	do
	{
		while( *pNextPasswd == '\r' ||  *pNextPasswd == '\n' )
			pNextPasswd++;

		if( *pNextPasswd == '\0' )
			return 401;//403;

		pPasswd = pNextPasswd;

		while( *pNextPasswd != '\r' &&  *pNextPasswd != '\n' && *pNextPasswd != '\0' )
		{
			pNextPasswd++;
		}
		if( *pNextPasswd != '\0' )
			*pNextPasswd++ = '\0';
		
		if( strcmp( pPasswd, p ) == 0 )
		{	
			// F؂ꂽI
			return nHttpStatus;
		}

		// 
	}while( *pNextPasswd != '\0' );

	return 401;//403;

}


//-----------------------------------------------------------------------------
//	@detail
//		NGXgC𕪊
//	@param
//		
//	@return
//		400 sȃNGXg
//		200 I
//		500 InternalServerError
//		501 not implement
//	RFC2616 sec.5.1
//		Request-Line   = Method SP Request-URI SP HTTP-Version CRLF
//-----------------------------------------------------------------------------
int MyHttpSock::WorkParseRequestLine(const char* pSrc)
{
	char szTmp1[HEADER_LINE_MAX],
		szTmp2[HEADER_LINE_MAX],
		szTmp3[HEADER_LINE_MAX];
	//-------------------------------------------
	// NGXgC̉
	//-------------------------------------------
	char* pReq = (char*)pSrc;
	
	//if( 3 != sscanf( pReq, "%s%s%s",szTmp1, szTmp2, szTmp3 ) )
	if( 3 > ParseRequestLine(pReq, szTmp1, szTmp2, szTmp3) )
		return 400;	// Bad Request


	// R}h̏Ɖ
	if( !strcmp( szTmp1, "GET" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPGET;
	}
	else if( !strcmp( szTmp1, "HEAD" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPHEAD;
	}
	else if( !strcmp( szTmp1, "POST" ) )
	{
		m_hrHttpReq.HttpCmd = HTTPPOST;
	}
	else if( 
		!strcmp( szTmp1, "PUT" )	||
		!strcmp( szTmp1, "DELETE" )	||
		!strcmp( szTmp1, "TRACE" )	||
		!strcmp( szTmp1, "OPTIONS" )||
		!strcmp( szTmp1, "CONNECT" )||
		!strcmp( szTmp1, "LINK" )	||
		!strcmp( szTmp1, "UNLINK" )	)
	{
		m_hrHttpReq.HttpCmd = HTTPNOTIMPLEMENTED;
		return 501;	// Not Implemented
	}
	else
	{
		m_hrHttpReq.HttpCmd = HTTPUNKNOWN;
		return 400;	// Bad Request
	}


	//-------------------------------------------
	// HTTPversion̉
	//-------------------------------------------
	if( !strcmp( szTmp3, "HTTP/1.0" ) || !strcmp( szTmp3, "HTTP/1.1" ) )
	{
		strcpy(m_hrHttpReq.szHttpVer, szTmp3);
	}
	else
	{
		// sȃo[W̏ꍇAԓHTTP/1.0ɂ
		strcpy(m_hrHttpReq.szHttpVer, "HTTP/1.0");
		return 400;	// Bad Request
	}

	//-------------------------------------------
	// pX̉
	//-------------------------------------------
	char* pszPathFrom = szTmp2;
	char* pszUrlPath	= m_hrHttpReq.szUrlPath;
	char* pszPathTo = m_hrHttpReq.szFilePath;

	// URIhttp://servername/..../̃p^[̏ꍇ
	// @RFC2616 sec.5.1.2 absoluteURI
	// Host͐Ɖ肷B
	// ԈĂvNVB
	if( !strncmp( pszPathFrom, "http://", 7 ) )
	{
		// http://servername:80/path/
		pszPathFrom += 7;
		// -> servername:80/path/
		
		if( NULL == (pszPathFrom = strstr(pszPathFrom, "/")) )
		{
			return 400;	// Bad Request
		}

		if( *pszPathFrom != '/' )
		{
			return 400;	// Bad Request
		}
		// -> /path/
	}

	// '/'  '\' ɕϊȂRs[
	// ?\0ŃRs[I
	while( *pszPathFrom != '\0' && *pszPathFrom != '?')
	{
		*pszUrlPath = *pszPathFrom;

		if( *pszPathFrom == '/' )
		{
			*pszPathTo = '\\';
		}
		else
		{
			*pszPathTo = *pszPathFrom;
		}
		
		pszPathFrom++;
		pszPathTo++;
		pszUrlPath++;
	}
	*pszPathTo = '\0';
	*pszUrlPath = '\0';

	// ------------------------------------------
	// ?ȍ~̓p[^Ƃm_hashReqHeadɊi[
	// ------------------------------------------
	if( *pszPathFrom == '?' )
	{
		pszPathFrom++;

		m_hashReqHeader.Set("QUERY_STRING", pszPathFrom);

		char* pParam = pszPathFrom;
		char* pKey;
		char* pValue;

		while( *pParam != '\0' )
		{
			pKey = szTmp1;
			pValue = szTmp2;

			// Get key
			while( *pParam != '\0' && *pParam != '=' && *pParam != '&' )
			{
				*pKey = *pParam;
				*pKey++;
				*pParam++;
			}
			*++pKey = '\0';
			*pParam++;
			// GetValue
			while( *pParam != '\0' && *pParam != '=' && *pParam != '&' )
			{
				*pValue = *pParam;
				*pValue++;
				*pParam++;
			}
			*++pValue = '\0';
			*pParam++;

			if( !m_hashReqHeader.Set(szTmp1, szTmp2) ||
				m_hashReqHeader.GetLength() > 4000)
			return 500;

		}
	}


	return 200;
}

//-----------------------------------------------------------------------------
//	@detail
//		NGXgC𕪉
//	@param
//
//	@return
//		擾łZeX̐
//-----------------------------------------------------------------------------
int MyHttpSock::ParseRequestLine( const char* pReq, char* szCmd, char* szPath, char* szHttpVer )
{
	// Method SP Request-URI SP HTTP-Version CRLF
	// pReq ͕K'\r\n'܂ł
	//szCmd̃obt@͕ۏ؂Ȃ̂ŁAĂяoŒ̂
	
	if( pReq == NULL || *pReq == '\0' )
		return 0;

	// szCmd
	while( *pReq != ' ' && *pReq != '\t' )
	{
		if( *pReq == '\0' || *pReq == '\r' || *pReq == '\n' )
		{
			*szCmd = '\0';
			return 1;
		}
		*szCmd++ = *pReq++;
	}
	*szCmd = '\0';
	pReq++;

	// szPath
	while( *pReq != ' ' && *pReq != '\t' )
	{
		if( *pReq == '\0' || *pReq == '\r' || *pReq == '\n' )
		{
			// HTTP verȗꂽꍇAHTTP/1.0Ƃď
			*szPath = '\0';
			strcpy(szHttpVer, "HTTP/1.0");
			return 3;
		}
		*szPath++ = *pReq++;
	}
	*szPath = '\0';
	pReq++;

	// szHttpVer
	while( *pReq != '\0' && *pReq != '\r' && *pReq != '\n' )
	{
		*szHttpVer++ = *pReq++;
	}
	*szHttpVer = '\0';
	return 3;

}


//-----------------------------------------------------------------------------
//	@detail
//		NGXgwb_[𕪊Am_hashReqHeaderɓĂ
//	@param
//		wb_[
//	@return
//		400 sȃNGXg
//		200 I
//		500 InternalServerError
//
//	@RFC2616 sec.5
//-----------------------------------------------------------------------------
int MyHttpSock::WorkParseRequestHeader(const char* pSrc)
{
	//-------------------------------------------
	// NGXgwb_tB[h̉
	//-------------------------------------------
	char szReqKey[HEADER_LINE_MAX], szReqValue[HEADER_LINE_MAX];

	char* pReq = (char*)pSrc;
	// NGXgC(GET /index.html HTTP/1.0 ...)̎̍s
	if( NULL == ( pReq = strstr( pReq, "\r\n" )) )
	{
		return 400;	// Bad Request
	}
	pReq += 2;
	
	while( *pReq != '\0' )
	{
		if( *pReq == '\r' )	// NGXgwb_[̏I
			break;
		
		if( 2 == ParseRequestHeader( (const char*)pReq, szReqKey, szReqValue ) )
		{
			// ǉ̎s
			if( !m_hashReqHeader.Set(szReqKey, szReqValue) ||
				m_hashReqHeader.GetLength() > 4000)
			return 500;
		}

		if( NULL == (pReq = strstr( pReq, "\r\n" )) )
			return 400;	// Bad Request

		pReq += 2;
	}
	return 200;
}

//-----------------------------------------------------------------------------
//	@detail
//		NGXgwb_[Fŕ
//	@param
//	@return
//		擾łZeX̐
//-----------------------------------------------------------------------------
int MyHttpSock::ParseRequestHeader( const char* pReq, char* szReqKey, char* szReqValue )
{
	if( pReq == NULL || *pReq == '\0' )
		return 0;

	// --------------------------------------------------------------
	// uFv܂łRs[B󔒂͖
	// --------------------------------------------------------------
	*szReqKey = *pReq;
	while( *pReq != ':' )
	{
		if( *pReq == ' ' || *pReq == '\t' )
		{
			*pReq++;
			continue;
		}
		else if( *pReq == '\r' || *pReq == '\n' || *pReq == '\0' )
		{
			*szReqKey = '\0';
			return 1;
		}
		*szReqKey = *pReq;
		szReqKey++;
		pReq++;
	}
	pReq++;
	*szReqKey = '\0';
	// --------------------------------------------------------------
	// uFvȍ~Rs[B̋󔒂͖
	// --------------------------------------------------------------
	while( *pReq == ' ' || *pReq == '\t' ) pReq++;

	while( *pReq != '\0' && *pReq != '\r'  && *pReq != '\n')
	{
		*szReqValue++ = *pReq++;
	}
	*szReqValue = '\0';
	return 2;
}

//-----------------------------------------------------------------------------
//	@detail
//		t@CpX
//		CGIǂ̔RRōs
//		̎dlɂCGI[gDoc[gzɂ邱ƂKvƂȂ
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔FȂ
//		}`XbhΉ̂߃NXo
//
//	@param
//		char*	pszSrc			/->\ɏꂽt@C
//								tpXɏ܂B
//								\xxx.html -> \<docroot>\xxx.html
//		int		nBufferSize		MAX_PATHoCgł邱ƂKvłB
//	@return
//		999
//		400
//		302
//		200
//	@out
//		m_hrHttpReq.wfdFile
//		m_hrHttpReq.szFileTime
//		pszSrc					
//-----------------------------------------------------------------------------
int MyHttpSock::WorkMakePath(char* pszSrc, int nBufferSize)
{
	//char szTmpSrc[MAX_PATH];
	int	bIsCgi = FALSE;
	char* p = pszSrc;

	char szFullPath[MAX_PATH];		// Ɨpobt@
	int	nFullPathLen;				// Ɨpobt@
	int nDRootLen = strlen(m_pServerInfo->pszDocRootName);
	int nCRootLen = strlen(m_pServerInfo->pszCgiRootName);
	int nSrcLen = strlen(pszSrc);

	memset( &m_hrHttpReq.wfdFile, 0, sizeof(WIN32_FIND_DATA) );

	// ȒPȃTCY`FbN
	if( nDRootLen + nSrcLen + 12/*\index.html|\0|*/ > nBufferSize )
		return 400;	// Bad Request

	// ------------------------------------------
	// fBNgZLeB`FbN
	// ------------------------------------------
	int count = 0;

	do{
		// \x	+1
		// \.	 0
		// ..	-1

		if( p[0] == '\\' && p[1] != '.' )
			count++;
		else if( p[0] == '.' && p[1] == '.' )
			count--;

		if( count < 1 )
			return 400;	// Bad Request

	}while( *++p != '\0' );

	// ------------------------------------------
	// hLg[gƃpX
	// ------------------------------------------
	// UnEscape( pszSrc );		// CEHTTP2.1
	szFullPath[0] = '\0';

	strcat( szFullPath, m_pServerInfo->pszDocRootName );
	strcat( szFullPath, pszSrc );

	nFullPathLen = strlen(szFullPath);

	// ------------------------------------------
	// CGIǂ̔
	// t@CpX̐擪CGI[gƓȂ
	// ------------------------------------------
	if( 0 == strncmp( szFullPath, m_pServerInfo->pszCgiRootName, 
									strlen(m_pServerInfo->pszCgiRootName) ) )
	{
		m_hashEnv.Set("PATH_INFO",	"");
		m_hashEnv.Set("PATH_TRANSLATED", m_pServerInfo->pszDocRootName);
		bIsCgi = TRUE;
	}

	// ------------------------------------------
	// fBNĝ݂w肵Ăꍇindex.htmlt
	// ------------------------------------------
	if( szFullPath[nFullPathLen-1] == '\\' )
	{
		if( !bIsCgi )
		{
			// mɃfBNgw肵Ă
			strcat( szFullPath, m_pServerInfo->pszDefaultDocName );
		}
	}

	// ------------------------------------------
	// unicodeϊ
	// ------------------------------------------
	// t@Č
	//HANDLE hFFF = FindFirstFile(ptszFile, &m_hrHttpReq.wfdFile );
	HANDLE hFFF = FindFirstFileMBCS(szFullPath, &m_hrHttpReq.wfdFile );

	if( INVALID_HANDLE_VALUE != hFFF )
	{
		// t@C𔭌
		FindClose(hFFF);

		// fBNg̏ꍇ͍Ō\index.htmltĕԂ
		if( m_hrHttpReq.wfdFile.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
		{
			// HTTP/1.1 302 Object Moved
			strcat( pszSrc, "\\" );
			strcat( pszSrc, m_pServerInfo->pszDefaultDocName );
			return 302;		//Object Moved.
		}
	}
	// ------------------------------------------
	// PATH_INFO ̂߂̍
	// ------------------------------------------
	else
	{
		if( bIsCgi )
		{
			char* pTmp = &szFullPath[nCRootLen+1];
			// <cgi_path>\sample.cgi\path1\path2\path3
			//            ^-p
			// /܂őOi
			for( ;*pTmp != '\\' && *pTmp != '\0'; pTmp++ );
			// \<cgi_path>\sample.cgi\path1\path2\path3
			//             ^-p

			while(1)
			{
				if( *pTmp == '\0' )
				{
					return 404;	// "Object Not Found"
				}
				
				*pTmp = '\0';

				hFFF = FindFirstFileMBCS(szFullPath, &m_hrHttpReq.wfdFile );

				// t@C݂ꍇ
				if(
					( INVALID_HANDLE_VALUE != hFFF ) &&
					!( m_hrHttpReq.wfdFile.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ))
				{
					// CGIĂԎm肵߂hashEnvɒl
					FindClose(hFFF);

					// PATH_INFO̐擪\t邽߂
					*pTmp = '\\';

					// --------------------------
					// PATH_INFO
					// --------------------------
					// UnEscape(pTmp);
					m_hashEnv.Set("PATH_INFO",	pTmp);
					bslash2slash(m_hashEnv.GetValue("PATH_INFO"));

					// --------------------------
					// PATH_TRANSLATED
					// --------------------------
					char	path_trans[MAX_PATH];
					if( nDRootLen + strlen( pTmp ) >= MAX_PATH -1 )
						return 400;
					strcpy( path_trans, m_pServerInfo->pszDocRootName );
					strcat( path_trans, pTmp );
					// UnEscape( path_trans );
					m_hashEnv.Set("PATH_TRANSLATED",	path_trans);
					slash2bslash(m_hashEnv.GetValue("PATH_TRANSLATED"));


					// PATH_INFOƍĂѕ
					*pTmp = '\0';

					break;
				}
				*pTmp++ = '\\';

				// /܂őOi
				for( ;*pTmp != '\\' && *pTmp != '\0'; pTmp++ );

			}			
		}
		else
		{
			return 404;	// "Object Not Found"
		}
	}
	strncpy( pszSrc, szFullPath, nBufferSize );

	// ------------------------------------------
	// CGIȂ΁AʃXe[^XR[h999ԐM
	// ------------------------------------------
	if(bIsCgi)
	{
		// --------------------------
		// SCRIPT_NAME
		// --------------------------
		m_hashEnv.Set("SCRIPT_NAME", &szFullPath[nDRootLen]);
		bslash2slash(m_hashEnv.GetValue("SCRIPT_NAME"));

		return 999;	// CGI
	}

	// tm_hrHttpReq.szFileTimeɏĂB
	// WorkGetFileFormat(&m_hrHttpReq.wfdFile.ftLastWriteTime, m_hrHttpReq.szFileTime);
	MyTime time(m_hrHttpReq.wfdFile.ftLastWriteTime);
	strcpy(m_hrHttpReq.szFileTime, time.GetFormatRfc1123());
	return 200;
}

//-----------------------------------------------------------------------------
//	@detail
//		ϐ쐬
//	@param
//	@return
//-----------------------------------------------------------------------------
void MyHttpSock::WorkMakeEnv()
{
	char work[MAX_PATH];
	
	// ------------------------------------------------------------------------
	// CONTENT_XXX
	// ------------------------------------------------------------------------
	sprintf(work, "%u", m_hReqBody.GetLength());
	m_hashEnv.Set("CONTENT_LENGTH",		work);
	m_hashEnv.Set("CONTENT_TYPE",		m_hashReqHeader.GetValueI("content-type"));
	
/*
	// ------------------------------------------------------------------------
	// PATH_XXX
	// ------------------------------------------------------------------------
	pwork = m_hashReqHeader.GetValue("path_info:");
	if( pwork != NULL )
	{
		sprintf(work, "%s%s", m_pServerInfo->pszDocRootName, pwork);
		m_hashEnv.Set("PATH_TRANSLATED",	work);

	}
*/	
	// ------------------------------------------------------------------------
	// QUERY_XXX
	// ------------------------------------------------------------------------
	m_hashEnv.Set("QUERY_STRING",		m_hashReqHeader.GetValue("QUERY_STRING"));
	
	// ------------------------------------------------------------------------
	// REMOTE_XXX
	// ------------------------------------------------------------------------
	sockaddr_in* psa = m_hrHttpReq.psaRemoteHost;
	u_char* p = (u_char*)&(psa->sin_addr.S_un.S_un_b);
	sprintf(work, "%u.%u.%u.%u", p[0], p[1], p[2], p[3]);
	m_hashEnv.Set("REMOTE_ADDR",		work);
	sprintf(work,"%d", psa->sin_port);
	m_hashEnv.Set("REMOTE_PORT",		work);
	//m_hashEnv.Set("REMOTE_HOST",		);	// DNSxɂXs[hቺ邽not support
	
	// ------------------------------------------------------------------------
	// REQUEST_XXX
	// ------------------------------------------------------------------------
	switch(m_hrHttpReq.HttpCmd)
	{
		case HTTPHEAD:
			m_hashEnv.Set("REQUEST_METHOD",		"HEAD");
			break;
		case HTTPGET:
			m_hashEnv.Set("REQUEST_METHOD",		"GET");
			break;
		case HTTPPOST:
			m_hashEnv.Set("REQUEST_METHOD",		"POST");
			break;
		default:
			m_hashEnv.Set("REQUEST_METHOD",		"");
			break;
	}

	// ------------------------------------------------------------------------
	// SERVER_XXX
	// ------------------------------------------------------------------------
	m_hashEnv.Set("SERVER_NAME",		m_hashReqHeader.GetValueI("host"));
	sprintf(work, "%u",					m_pServerInfo->nPort);
	m_hashEnv.Set("SERVER_PORT",		work);
	m_hashEnv.Set("SERVER_PROTOCOL",	m_hrHttpReq.szHttpVer);
	m_hashEnv.Set("SERVER_SOFTWARE",	m_pServerInfo->pszSoftware);
	
	// ------------------------------------------------------------------------
	// HTTP_XXX
	// ------------------------------------------------------------------------
	m_hashEnv.Set("HTTP_ACCEPT",		m_hashReqHeader.GetValueI("accept"));
	m_hashEnv.Set("HTTP_USER_AGENT",	m_hashReqHeader.GetValueI("user-agent"));
	m_hashEnv.Set("HTTP_COOKIE",		m_hashReqHeader.GetValueI("cookie"));
	m_hashEnv.Set("HTTP_REFERER",		m_hashReqHeader.GetValueI("referer"));
	
	// ------------------------------------------------------------------------
	// DOCUMENT_XXX
	// ------------------------------------------------------------------------
	m_hashEnv.Set("DOCUMENT_ROOT",		m_pServerInfo->pszDocRootName);
}

//-----------------------------------------------------------------------------
//	@detail
//		f[^|
//	@param
//	@return
//-----------------------------------------------------------------------------
void MyHttpSock::FreeMemory()
{
	m_hReqHead.Clear();
	m_hReqBody.Clear();
	m_hashReqHeader.Clear();
	m_hashEnv.Clear();
}

