// MyHttpSock.h: MyHttpSock NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MYHTTPSOCK_H__EAA73A6E_8C40_4F9B_8BC3_72CF9A94131F__INCLUDED_)
#define AFX_MYHTTPSOCK_H__EAA73A6E_8C40_4F9B_8BC3_72CF9A94131F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MySock.h"
#include "MyVarMem.h"
#include "MyHash.h"

//-----------------------------------------------
enum HTTPCMD
{
	HTTPUNKNOWN = 0,	// bad request
	HTTPHEAD,			// Implemented
	HTTPGET,			// Implemented
	HTTPPOST,
	/* Not Implemented
	HTTPPUT,
	HTTPDELETE,
	HTTPTRACE,
	HTTPOPTIONS,
	HTTPCONNECT,
	HTTPLINK,
	HTTPUNLINK
	*/
	HTTPNOTIMPLEMENTED
};

//-----------------------------------------------
// T[o
// Oݒ肳AeNXʂŗp
//-----------------------------------------------
typedef struct tagServerInfo
{
	int		nPort;
	char*	pszSoftware;
	char*	pszDocRootName;
	char*	pszCgiRootName;
	char*	pszDefaultDocName;
	char*	pszAccessFileName;
} SERVER_INFO, *LPSERVER_INFO;

//-----------------------------------------------
// CONTENT_TYPE
// MIME^CvƊgq֘At
//-----------------------------------------------
typedef struct tagCONTENT_TYPE
{
	const char* pszExt;
	const char* pszMIME;
} CONTENT_TYPE, *LPCONTENT_TYPE;

//-----------------------------------------------
// HTTP_REQUEST
// NGXgǂݎW
//-----------------------------------------------
typedef struct tagHTTP_REQUEST
{
	// Request line
	HTTPCMD			HttpCmd;				// GET, HEAD, POST,...
	char			szUrlPath[MAX_PATH];	// Url̃pX
	char			szFilePath[MAX_PATH];	// t@C̃pX
	char			szHttpVer[16];			// HTTP̃o[W
	
	WIN32_FIND_DATA	wfdFile;				// w肳ꂽt@C
	char			szFileTime[32];			// t@C^C
	sockaddr_in*	psaRemoteHost;			// [gzXg

} HTTP_REQUEST, *LPHTTP_REQUEST;

//-----------------------------------------------
// HTTPXe[^Xƕ֘At
//-----------------------------------------------
typedef struct tagHTTP_STATUS
{
	int nStatus;
	const char* pszString;
} HTTP_STATUS, *LPHTTP_STATUS;

//-----------------------------------------------
class MyHttpSock : public MySock  
{
public:
	MyHttpSock(SOCKET s);
	MyHttpSock();
	virtual ~MyHttpSock();

	LPSERVER_INFO	m_pServerInfo;	// Servers infomation
	MyHash			m_hashReqHeader;// Request header lines
	MyHash			m_hashEnv;		// Environment
	HTTP_REQUEST	m_hrHttpReq;	// HTTP_REQUEST
	MyVarMem		m_hReqHead;		// HTTP request header
	MyVarMem		m_hReqBody;		// HTTP request body

public:
	void	FreeMemory();
	int		SendResponse(int nHttpStatus, int bConnectionClose = 1);
	int		RecvRequest(int* pbConnectionClose);
	int		WorkMakePath(char* pszSrc, int nBufferSize = MAX_PATH);

protected:
	//static char* m_pszMonth[12];
	//static char* m_pszWeek[7];
	DWORD	m_dwRecvTimeOut;
protected:
	int		CheckBasicAuth(int nHttpStatus, const char* pszFilePath, const char* pszBAuthFile);
	int		CheckBasicAuthFile(int nHttpStatus, char* pszAuthFilePath);
	int		SendDefaultHttpResponse(int nHttpStatus, int bConnectionClose = 0, int nAddtionalInfo = 0);
//	void	WorkGetFileFormat(FILETIME* pft, char* pszDst);
//	int		WorkIfModifiedSince(const char* pszFileTime);
	void	WorkMakeEnv();

	int		WorkParseRequestHeader(const char* pSrc);
	int		ParseRequestHeader( const char* pReq, char* szReqKey, char* szReqValue );
	int		WorkParseRequestLine(const char* pSrc );
	int		ParseRequestLine(const char* pReq, char* szCmd, char* szPath, char* szHttpVer);
private:
};

#endif // !defined(AFX_MYHTTPSOCK_H__EAA73A6E_8C40_4F9B_8BC3_72CF9A94131F__INCLUDED_)
