#include <stdlib.h>
#include "httphelper.h"

TCHAR*	szG_VERSION_OF_HTTPHELPER_CPP = TEXT(__TIMESTAMP__);


// ----------------------------------------------------------------------------
// HELPER FUNCTIONS
// ----------------------------------------------------------------------------
static char B64(char c)
{
	if( c == '=' ) return 0;
	const char b64[] ="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	for( char ii = 0; b64[ii] != c && b64 != '\0'; ii++ );
	return ii;
}

char* Base64Decord(unsigned char *buf)
{
    char *p = (char*)buf;

    int l = strlen((const char*)buf);
    for (int ii=0,jj=0; ii<l; ii+=4, jj+=3)
	{
        p[jj]   =(char)(  (B64(buf[ii])           << 2) | ((B64(buf[ii+1]) & 0x30) >> 4) );
        p[jj+1] =(char)( ((B64(buf[ii+1]) & 0x0f) << 4) | ((B64(buf[ii+2]) & 0x3c) >> 2) );
        p[jj+2] =(char)( ((B64(buf[ii+2]) & 0x03) << 6) |  (B64(buf[ii+3]) & 0x3f)       );
    }
    p[jj] = '\0';
    return (p);
}

//-----------------------------------------------------------------------------
// '/' -> '\\'
void slash2bslash(char* str)
{
	if( str == NULL )
		return;

	for( ;*str;str++)
		if( *str == '/' ) *str = '\\';
}

//-----------------------------------------------------------------------------
// '/' <- '\\'
void bslash2slash(char* str)
{
	if( str == NULL )
		return;

	for( ;*str;str++)
		if( *str == '\\' ) *str = '/';
}

//-----------------------------------------------------------------------------
// FindFirstFile MBCS
HANDLE FindFirstFileMBCS(char* lpFileName, LPWIN32_FIND_DATA lpFindFileData )
{
	TCHAR	tszFile[MAX_PATH];

	if( 0 == MultiByteToWideChar(CP_ACP,0,lpFileName,-1,tszFile,MAX_PATH) )
	{
		return INVALID_HANDLE_VALUE;
	}

	// t@Č
	return FindFirstFile(tszFile, lpFindFileData );
}

//-----------------------------------------------------------------------------
// ɕϊ܂B
int mytolower( int c )
{
	return (( c >= 'A' && c <= 'Z' ) ? c += ('a'-'A') : c);
}

//-----------------------------------------------------------------------------
// ɕϊB
char *my_strlwr( char *string )
{
	if( !string )
		return NULL;

	while( *string )
	{
		*string = mytolower( *string );
	}
	return string;
}

//-----------------------------------------------------------------------------
// 񒆂̕ƂĔr܂B
int my_stricmp( const char *str1, const char *str2 )
{
	do
	{
		if( mytolower(*str1) != mytolower(*str2) )
			return mytolower(*str2) - mytolower(*str1);
	}while( *str1++ && *str2++ );

	return 0;
}

//-----------------------------------------------------------------------------
// 񒆂̕ƂĔr܂B
int my_strnicmp( const char *str1, const char *str2, size_t n )
{
	do
	{
		if( !n-- ) return 0;
		if( mytolower(*str1) != mytolower(*str2) )
			return mytolower(*str2) - mytolower(*str1);
	}while( *str1++ && *str2++ );

	return 0;
}

//-----------------------------------------------------------------------------
// mallocgĕ܂
// Jfree𗘗pĉB
char* my_strdup( const char* strSrc )
{
	int nLen;
	char* pNew;

	if( strSrc == NULL ) return NULL;

	nLen = strlen(strSrc);
	//pNew = new char[nLen + 1];
	pNew = (char*)malloc(nLen+1);
	
	if( pNew )
	{
		strcpy( pNew, strSrc );
	}
	return pNew;
}
/*
//-----------------------------------------------------------------------------
// ASCII -> 16x
//-----------------------------------------------------------------------------
inline char AtoH( char c )
{
  if( '0' <= c && c <= '9' ) return c - '0';
  if( 'A' <= c && c <= 'F' ) return c - 'A' + 10;
  return 0;
}

// ----------------------------------------------------------------------------
// %XX ϊ
// ----------------------------------------------------------------------------
void UnEscape( char* src )
{
	char* dst;
	for( dst=src; *src; src++ ) {
		if( *src == '%' ) {
			if( *(src+1) != '%' ) {
#ifdef SHx	// jornada sh΍
				*dst++ = (AtoH(*++src)) + (AtoH(*++src)<<4);
#else
				*dst++ = (AtoH(*++src)<<4) + AtoH(*++src);
#endif
			}
			else {
				*dst++;
				*src++;
			}
		}else if( *src == '+' ) {
			*dst++ = ' ';
		}
		else {
			*dst++ = *src;
		}
	}
	*dst++ = '\0';
}
*/